import type { IDebugger } from 'debug';
import type { Handler } from './handler';
export declare enum Iteration {
    THROW = "throw",
    CONTINUE = "continue",
    BREAK = "break",
    RETURN = "return"
}
export declare type ExecutionResult<ReturnValue> = {
    iteration: Iteration.CONTINUE | Iteration.BREAK | Iteration.THROW;
    error: Error;
} | {
    iteration: Iteration.RETURN;
    value: ReturnValue;
};
export declare function executeHandler<Arguments extends unknown[], Self, Trigger extends Error, ReturnValue>(handler: Handler<Arguments, Self, Trigger, ReturnValue>, context: {
    self: Self;
    error: Trigger;
    parameters: Arguments;
}, debug: IDebugger): Promise<ExecutionResult<ReturnValue>>;
