import type { IDebugger } from 'debug';
import type { Class } from 'type-fest';
import type { ShumwayError } from '../error';
import { Iteration } from '../execute-handler';
import type { Handler } from './handler';
export declare function handleCallbackError<Arguments extends unknown[], Self, Trigger extends Error, ReturnValue>({ trigger, callbackError, WrapperClass, handler, }: {
    trigger: Error;
    callbackError: Error;
    WrapperClass: Class<ShumwayError>;
    handler: Handler<Arguments, Self, Trigger, ReturnValue>;
}, debug: IDebugger): {
    iteration: Iteration.THROW | Iteration.BREAK | Iteration.CONTINUE;
    error: Error;
};
