"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.recoverHandler = void 0;
const execute_handler_1 = require("../../execute-handler");
const handle_callback_error_1 = require("../handle-callback-error");
const recover_error_1 = require("./recover.error");
async function recoverHandler(debug, context, handler) {
    try {
        const value = await handler.callback.call(context.self, context.error, ...context.parameters);
        debug('recover callback executed successfully');
        return { iteration: execute_handler_1.Iteration.RETURN, value };
    }
    catch (callbackError) {
        return (0, handle_callback_error_1.handleCallbackError)({
            trigger: context.error,
            callbackError: callbackError,
            WrapperClass: recover_error_1.RecoverError,
            handler,
        }, debug);
    }
}
exports.recoverHandler = recoverHandler;
