"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sideEffectHandler = void 0;
const execute_handler_1 = require("../../execute-handler");
const handle_callback_error_1 = require("../handle-callback-error");
const side_effect_error_1 = require("./side-effect.error");
async function sideEffectHandler(debug, context, handler) {
    try {
        await handler.callback.call(context.self, context.error, ...context.parameters);
        debug('side effect handler executed successfully');
        return { iteration: execute_handler_1.Iteration.BREAK, error: context.error };
    }
    catch (callbackError) {
        return (0, handle_callback_error_1.handleCallbackError)({
            trigger: context.error,
            callbackError: callbackError,
            WrapperClass: side_effect_error_1.SideEffectError,
            handler,
        }, debug);
    }
}
exports.sideEffectHandler = sideEffectHandler;
