"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tapHandler = void 0;
const execute_handler_1 = require("../../execute-handler");
async function tapHandler(debug, context, handler) {
    try {
        await handler.callback.call(context.self, context.error, ...context.parameters);
        debug('tap callback executed successfully');
        return { iteration: execute_handler_1.Iteration.CONTINUE, error: context.error };
    }
    catch (callbackError) {
        debug('tap callback threw an error: %s', callbackError.message);
        return { iteration: execute_handler_1.Iteration.CONTINUE, error: context.error };
    }
}
exports.tapHandler = tapHandler;
